/*
	DynAPI Distribution
	dynapi.functions extension
	
	The DynAPI Distribution is distributed under the terms of the GNU LGPL license.
*/

dynapi.functions.DecToHex = function(val){
	lo=val%16;
	val-=lo;
	lo+=48;
	if (lo>57) lo+=7;
	hi=val/16;
	hi+=48;
	if (hi>57) hi+=7;
	return String.fromCharCode(hi,lo);
};
dynapi.functions.getColor = function(r,g,b) { 
	return '#'+dynapi.functions.DecToHex(r)+dynapi.functions.DecToHex(g)+dynapi.functions.DecToHex(b);
};
dynapi.functions.createRedPal = function(pal) {
	var r=g=b=0;
	for (var i=0; i<256; i++){
		pal[i]=dynapi.functions.getColor(r,g,b);
		r+=8;
		if (r>255) { r=255; g+=6; b+=2; }
		if (g>255) { g=255; b+=2; }
		if (b>255) { b=255; }
	}
};
dynapi.functions.createGrayPal = function(pal) {
	var r=0;
	for (var i=0; i<256; i++){
		pal[i]=dynapi.functions.getColor(r,r,r);
		r+=4;
		if (r>255) { r=255; }
	}
};
dynapi.functions.createBluePal = function(pal){
	var r=g=b=0;
	for (var i=0; i<256; i++){
		pal[i]=dynapi.functions.getColor(r,g,b);
		b+=6;
		if (b>255) { b=255; g+=2; }
		if (g>255) { g=255; r+=2; }
	}
};
dynapi.functions.createGreenPal = function(pal) {
	var r=g=b=0;
	for (var i=0; i<256; i++){
		pal[i]=dynapi.functions.getColor(r,g,b);
		g+=6;
		if (g>255) { g=255; b+=2; }
		if (b>255) { b=255; r+=2; }
	}
};
dynapi.functions.radianToDegree = function(radian) {
	return radian*180/Math.PI
};
dynapi.functions.degreeToRadian = function(degree) {
	return degree*Math.PI/180
};
dynapi.functions.sintable = function(lsin) {
	for (var i=0; i<361; i+=1) lsin[i]=Math.sin((i/180)*Math.PI);
};
dynapi.functions.costable = function(lcos) {
	for (var i=0; i<361; i+=1) lcos[i]=Math.cos((i/180)*Math.PI);
};